#include "libcDAG.hpp"
#include <assert.h>

int main() {

  MPI_Init(NULL, NULL);
  MPI_Comm comm=MPI_COMM_WORLD;
  int r,p;
  MPI_Comm_rank(comm,&r);
  MPI_Comm_size(comm,&p);

  cDAG_Init();
  assert(cDAG_IsInitialized() == 1);
  assert(cDAG_GroupSize() == p);
  assert(cDAG_MyRank() == r);

  int a=r;
  int b=-1;
  cDAG_Graph g = cDAG_Create_graph();

  cDAG_Vertex send = cDAG_Send(g, &a, sizeof(int), (r+1)%p);
  cDAG_Vertex recv = cDAG_Recv(g, &b, sizeof(int), (r-1+p)%p);

  cDAG_Schedule sched = cDAG_Compile(g);
  cDAG_FreeGraph(g);
  cDAG_Handle hndl;

  printf("[%i] %i\n", r, b);
  hndl = cDAG_Run(sched);
  cDAG_Wait(hndl);
  printf("[%i] %i\n", r, a);
  
  cDAG_Finalize();

  MPI_Finalize();

}
